SELECT "users_user"."id",
       "users_user"."password",
       "users_user"."last_login",
       "users_user"."email",
       "users_user"."display_name",
       "users_user"."transkribus_email",
       "users_user"."is_active",
       "users_user"."is_internal",
       "users_user"."is_admin",
       "users_user"."verified_email"
FROM "users_user"
WHERE "users_user"."id" = {user_id}
LIMIT 21;

SELECT "documents_element"."id",
       "documents_element"."corpus_id",
       "documents_corpus"."created",
       "documents_corpus"."updated",
       "documents_corpus"."id",
       "documents_corpus"."name",
       "documents_corpus"."description",
       "documents_corpus"."repository_id",
       "documents_corpus"."public"
FROM "documents_element"
INNER JOIN "documents_corpus" ON ("documents_element"."corpus_id" = "documents_corpus"."id")
WHERE ("documents_element"."corpus_id" IN
           (SELECT DISTINCT U0."id"
            FROM "documents_corpus" U0
            LEFT OUTER JOIN "users_corpusright" U1 ON (U0."id" = U1."corpus_id")
            WHERE (U0."public"
                   OR U1."user_id" = {user_id}))
       AND "documents_element"."id" = '{id}'::uuid)
LIMIT 21;

SELECT "users_corpusright"."id",
       "users_corpusright"."user_id",
       "users_corpusright"."corpus_id",
       "users_corpusright"."can_write",
       "users_corpusright"."can_admin"
FROM "users_corpusright"
WHERE ("users_corpusright"."corpus_id" = '{corpus_id}'::uuid
       AND "users_corpusright"."user_id" = {user_id})
LIMIT 21;


DELETE
FROM documents_transcriptionentity te
WHERE transcription_id IN
        (SELECT t.id
         FROM documents_transcription t
         LEFT JOIN documents_elementpath elementpath USING (element_id)
         WHERE t.element_id = '{id}'::uuid
             OR elementpath.path && ARRAY['{id}'::uuid] ) ;


DELETE
FROM documents_transcription
WHERE element_id = '{id}'::uuid
    OR element_id IN
        (SELECT element_id
         FROM documents_elementpath
         WHERE path && ARRAY['{id}'::uuid] ) ;


DELETE
FROM documents_classification
WHERE element_id = '{id}'::uuid
    OR element_id IN
        (SELECT element_id
         FROM documents_elementpath
         WHERE path && ARRAY['{id}'::uuid] ) ;


DELETE
FROM documents_metadata
WHERE element_id = '{id}'::uuid
    OR element_id IN
        (SELECT element_id
         FROM documents_elementpath
         WHERE path && ARRAY['{id}'::uuid] ) ;


DELETE
FROM dataimport_dataimportelement
WHERE element_id = '{id}'::uuid
    OR element_id IN
        (SELECT element_id
         FROM documents_elementpath
         WHERE path && ARRAY['{id}'::uuid] ) ;


UPDATE dataimport_dataimport
SET element_id = NULL
WHERE element_id = '{id}'::uuid
    OR element_id IN
        (SELECT element_id
         FROM documents_elementpath
         WHERE path && ARRAY['{id}'::uuid] ) ;


DELETE
FROM documents_selection selection
WHERE element_id = '{id}'::uuid
    OR element_id IN
        (SELECT element_id
         FROM documents_elementpath
         WHERE path && ARRAY['{id}'::uuid] ) ;

WITH children_ids (id) AS
    (DELETE
     FROM documents_elementpath
     WHERE element_id = '{id}'::uuid
         OR path && ARRAY['{id}'::uuid] RETURNING element_id)
DELETE
FROM documents_element element USING children_ids
WHERE element.id = children_ids.id ;

DELETE
FROM "documents_element"
WHERE "documents_element"."id" = '{id}'::uuid
